var xbox360pad: BABYLON.Xbox360Pad;
var genericpad: BABYLON.GenericPad;

var buttonPressed = document.getElementById("buttonPressed");
var buttonReleased = document.getElementById("buttonReleased");
var xboxButtonPressed = document.getElementById("xboxButtonPressed");
var xboxButtonReleased = document.getElementById("xboxButtonReleased");

var dpadPressed = document.getElementById("dpadPressed");
var dpadReleased = document.getElementById("dpadReleased");
var leftStickValues = document.getElementById("leftStickValues");
var rightStickValues = document.getElementById("rightStickValues");
var leftTriggerValue = document.getElementById("leftTriggerValue");
var rightTriggerValue = document.getElementById("rightTriggerValue");
var Xbox360Section = document.getElementById("Xbox360Section");
var startingInstructions = document.getElementById("startingInstructions");
var padLogs = document.getElementById("padLogs");
var GenericPadSection = document.getElementById("GenericPadSection");

var gamepadConnected = function (gamepad: BABYLON.Gamepad) {
    startingInstructions.className = "hidden";
    padLogs.className = "";

    if (gamepad.index === 0) {
        gamepad.onleftstickchanged(function (values: BABYLON.StickValues) {
            leftStickValues.innerHTML = "X: " + values.x + " Y: " + values.y;
        });
        gamepad.onrightstickchanged(function (values: BABYLON.StickValues) {
            rightStickValues.innerHTML = "X: " + values.x + " Y: " + values.y;
        });
        if (gamepad instanceof BABYLON.Xbox360Pad) {
            Xbox360Section.className = "";
            xbox360pad = <BABYLON.Xbox360Pad> gamepad;
            xbox360pad.onlefttriggerchanged(function (value: number) {
                leftTriggerValue.innerHTML = value.toString();
            });
            xbox360pad.onrighttriggerchanged(function (value: number) {
                rightTriggerValue.innerHTML = value.toString();
            });
            xbox360pad.onbuttondown(function (button: BABYLON.Xbox360Button) {
                switch (button) {
                    case BABYLON.Xbox360Button.A:
                        xboxButtonPressed.innerHTML = "A pressed";
                        break;
                    case BABYLON.Xbox360Button.B:
                        xboxButtonPressed.innerHTML = "B pressed";
                        break;
                    case BABYLON.Xbox360Button.X:
                        xboxButtonPressed.innerHTML = "X pressed";
                        break;
                    case BABYLON.Xbox360Button.Y:
                        xboxButtonPressed.innerHTML = "Y pressed";
                        break;
                    case BABYLON.Xbox360Button.Back:
                        xboxButtonPressed.innerHTML = "Back pressed";
                        break;
                    case BABYLON.Xbox360Button.Start:
                        xboxButtonPressed.innerHTML = "Start pressed";
                        break;
                    case BABYLON.Xbox360Button.LB:
                        xboxButtonPressed.innerHTML = "LB pressed";
                        break;
                    case BABYLON.Xbox360Button.RB:
                        xboxButtonPressed.innerHTML = "RB pressed";
                        break;
                    case BABYLON.Xbox360Button.LeftStick:
                        xboxButtonPressed.innerHTML = "LeftStick pressed";
                        break;
                    case BABYLON.Xbox360Button.RightStick:
                        xboxButtonPressed.innerHTML = "RightStick pressed";
                        break;
                }
            });
            xbox360pad.onbuttonup(function (button: BABYLON.Xbox360Button) {
                switch (button) {
                    case BABYLON.Xbox360Button.A:
                        xboxButtonReleased.innerHTML = "A released";
                        break;
                    case BABYLON.Xbox360Button.B:
                        xboxButtonReleased.innerHTML = "B released";
                        break;
                    case BABYLON.Xbox360Button.X:
                        xboxButtonReleased.innerHTML = "X released";
                        break;
                    case BABYLON.Xbox360Button.Y:
                        xboxButtonReleased.innerHTML = "Y released";
                        break;
                    case BABYLON.Xbox360Button.Back:
                        xboxButtonReleased.innerHTML = "Back released";
                        break;
                    case BABYLON.Xbox360Button.Start:
                        xboxButtonReleased.innerHTML = "Start released";
                        break;
                    case BABYLON.Xbox360Button.LB:
                        xboxButtonReleased.innerHTML = "LB released";
                        break;
                    case BABYLON.Xbox360Button.RB:
                        xboxButtonReleased.innerHTML = "RB released";
                        break;
                    case BABYLON.Xbox360Button.LeftStick:
                        xboxButtonReleased.innerHTML = "LeftStick released";
                        break;
                    case BABYLON.Xbox360Button.RightStick:
                        xboxButtonReleased.innerHTML = "RightStick released";
                        break;
                }
            });
            xbox360pad.ondpaddown(function (button: BABYLON.Xbox360Dpad) {
                switch (button) {
                    case BABYLON.Xbox360Dpad.Down:
                        dpadPressed.innerHTML = "Down pressed";
                        break;
                    case BABYLON.Xbox360Dpad.Left:
                        dpadPressed.innerHTML = "Left pressed";
                        break;
                    case BABYLON.Xbox360Dpad.Right:
                        dpadPressed.innerHTML = "Right pressed";
                        break;
                    case BABYLON.Xbox360Dpad.Up:
                        dpadPressed.innerHTML = "Up pressed";
                        break;
                }
            });
            xbox360pad.ondpadup(function (button: BABYLON.Xbox360Dpad) {
                switch (button) {
                    case BABYLON.Xbox360Dpad.Down:
                        dpadReleased.innerHTML = "Down released";
                        break;
                    case BABYLON.Xbox360Dpad.Left:
                        dpadReleased.innerHTML = "Left released";
                        break;
                    case BABYLON.Xbox360Dpad.Right:
                        dpadReleased.innerHTML = "Right released";
                        break;
                    case BABYLON.Xbox360Dpad.Up:
                        dpadReleased.innerHTML = "Up released";
                        break;
                }
            });
        }
        else {
            GenericPadSection.className = "";
            genericpad = <BABYLON.GenericPad> gamepad;
            genericpad.onbuttondown(function (buttonIndex: number) {
                buttonPressed.innerHTML = "Button " + buttonIndex + " pressed";
            });
            genericpad.onbuttonup(function (buttonIndex: number) {
                buttonReleased.innerHTML = "Button " + buttonIndex + " released";
            });
        }
    }
};

var gamepads = new BABYLON.Gamepads(gamepadConnected);






